Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QFutureIterator

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QFutureIterator

All Implemented Interfaces:
  QtJambiInterface

    public class QFutureIterator

extends QtJambiObject

The QFutureIterator class provides a Java-style const iterator for `QFuture`. `QFuture` has both Java-style iterators and STL-style iterators. The Java-style iterators are more high-level and easier to use than the STL-style iterators; on the other hand, they are slightly less efficient.

An alternative to using iterators is to use index positions. Some `QFuture` member functions take an index as their first parameter, making it possible to access results without using iterators.

QFutureIterator<T> allows you to iterate over a `QFuture`<T>. Note that there is no mutable iterator for `QFuture` (unlike the other Java-style iterators).

The QFutureIterator constructor takes a `QFuture` as its argument. After construction, the iterator is located at the very beginning of the result list (i.e. before the first result). Here's how to iterate over all the results sequentially:

            QFuture<String> future = new QFuture<String>();
             ...

            QFutureIterator<String> i = new QFutureIterator<String>(future);
            while (i.hasNext())
                System.out.println(i.next());

The `next()` function returns the next result (waiting for it to become available, if necessary) from the future and advances the iterator. Unlike STL-style iterators, Java-style iterators point between results rather than directly at results. The first call to `next()` advances the iterator to the position between the first and second result, and returns the first result; the second call to `next()` advances the iterator to the position between the second and third result, and returns the second result; and so on.
Here's how to iterate over the elements in reverse order:

            QFutureIterator<String> i = new QFutureIterator<String>(future);
            i.toBack();
            while (i.hasPrevious())
                System.out.println(i.previous());

If you want to find all occurrences of a particular value, use `findNext()` or `findPrevious()` in a loop.

Multiple iterators can be used on the same future. If the future is modified while a QFutureIterator is active, the QFutureIterator will continue iterating over the original future, ignoring the modified copy.

See also:
  QFuture::const_iterator, and `QFuture`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QFutureIterator(QFuture container)` Constructs an iterator for traversing `future`.

Method Summary
`boolean` | `findNext(java.lang.Object t)` Searches for `value` starting from the current iterator position forward.
`boolean` | `findPrevious(java.lang.Object t)` Searches for `value` starting from the current iterator position backward.
`boolean` | `hasNext()` Returns true if there is at least one result ahead of the iterator, e.
`boolean` | `hasPrevious()` Returns true if there is at least one result ahead of the iterator, e.
`java.lang.Object` | `next()` Returns the next result and advances the iterator by one position.
`java.lang.Object` | `peekNext()` Returns the next result without moving the iterator.
`java.lang.Object` | `peekPrevious()` Returns the previous result without moving the iterator.
`java.lang.Object` | `previous()` Returns the previous result and moves the iterator back by one position.
`void` | `toBack()` Moves the iterator to the back of the result list (after the last result).
`void` | `toFront()` Moves the iterator to the front of the result list (before the first result).

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QFutureIterator

    public QFutureIterator(QFuture container)

  Constructs an iterator for traversing `future`. The iterator is set to be at the front of the result list (before the first result).

See also:
  operator=().

Method Detail

### findNext

    public final boolean findNext(java.lang.Object t)

  Searches for `value` starting from the current iterator position forward. Returns true if `value` is found; otherwise returns false.

  After the call, if `value` was found, the iterator is positioned just after the matching result; otherwise, the iterator is positioned at the back of the result list.

See also:
  `findPrevious()`.

### findPrevious

    public final boolean findPrevious(java.lang.Object t)

  Searches for `value` starting from the current iterator position backward. Returns true if `value` is found; otherwise returns false.

  After the call, if `value` was found, the iterator is positioned just before the matching result; otherwise, the iterator is positioned at the front of the result list.

See also:
  `findNext()`.

### hasNext

    public final boolean hasNext()

  Returns true if there is at least one result ahead of the iterator, e. ., the iterator is not at the back of the result list; otherwise returns false.

See also:
  `hasPrevious()`, and `next()`.

### hasPrevious

    public final boolean hasPrevious()

  Returns true if there is at least one result ahead of the iterator, e. ., the iterator is not at the front of the result list; otherwise returns false.

See also:
  `hasNext()`, and `previous()`.

### next

    public final java.lang.Object next()

  Returns the next result and advances the iterator by one position.

  Calling this function on an iterator located at the back of the result list leads to undefined results.

See also:
  `hasNext()`, `peekNext()`, and `previous()`.

### peekNext

    public final java.lang.Object peekNext()

  Returns the next result without moving the iterator.

  Calling this function on an iterator located at the back of the result list leads to undefined results.

See also:
  `hasNext()`, `next()`, and `peekPrevious()`.

### peekPrevious

    public final java.lang.Object peekPrevious()

  Returns the previous result without moving the iterator.

  Calling this function on an iterator located at the front of the result list leads to undefined results.

See also:
  `hasPrevious()`, `previous()`, and `peekNext()`.

### previous

    public final java.lang.Object previous()

  Returns the previous result and moves the iterator back by one position.

  Calling this function on an iterator located at the front of the result list leads to undefined results.

See also:
  `hasPrevious()`, `peekPrevious()`, and `next()`.

### toBack

    public final void toBack()

  Moves the iterator to the back of the result list (after the last result).

See also:
  `toFront()`, and `previous()`.

### toFront

    public final void toFront()

  Moves the iterator to the front of the result list (before the first result).

See also:
  `toBack()`, and `next()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD